﻿namespace DelegatesAndStuff
{
    /// <summary>
    /// Ukol: Prace s lambda vyrazy
    /// 
    /// I. Implementace lambda vyrazu v
    ///    nize uvedenych testovacich 
    ///    metodach, veskere info je v 
    ///    prislusnych popiscich
    /// 
    /// II. Dokonceni implementace tridy 
    ///     Utils, vsechny mista jsou 
    ///     oznaceny (TODO)
    /// 
    /// III. spusteni projektu
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            CommandDictionaryDemo();

            TestPrintSeparately();
            TestGreaterThan();
            TestPalindrome();
        }

        private static void CommandDictionaryDemo()
        {
            Dictionary<string, Action> commands = new()
            {
                ["info"] = PrintInfo,
                ["rip"] = () => Environment.Exit(0)
            };

            Console.WriteLine("Available commands: " + String.Join(" | ", commands.Keys));
            string? input = Console.ReadLine();
            if (input != null && commands.TryGetValue(input, out var action))
            {
                action.Invoke();
            }
            Console.WriteLine();
        }

        private static void PrintInfo()
        {
            Console.WriteLine("Printing info...");
        }

        /// <summary>
        /// Ukol: prvky z dane kolekce vypsat na samostatne radky
        /// </summary>
        private static void TestPrintSeparately()
        {
            Console.WriteLine(nameof(TestPrintSeparately));
            IEnumerable<string> collection = new List<string> { "these", "are", "some", "elements" };

            // TODO:
            // collection.ForEach( ...zde prijde lambda vyraz... );

            Console.WriteLine();
            Console.ReadKey();
        }

        /// <summary>
        /// Ukol: vypsat prvky z teto kolekce, ktere ostre mensi nez 15
        /// </summary>
        private static void TestGreaterThan()
        {
            Console.WriteLine(nameof(TestGreaterThan));
            var numbersToFilter = new[] { 0, 1, 3, 12, 8, 7, 43, 18, 93, 26, 57 };

            // TODO:
            // numbersToFilter.Where( ...zde prijde lambda vyraz... ).ForEach( ...zde prijde lambda vyraz... );
            
            // TODO: zkuste si tato volani projit debuggerem.
            // Vykonaji se metody jedna po druhe, nebo se vzajemne provolavaji?
            //
            // Ted vlozte mezi Where() a ForEach() metodu ToList().
            // Zmenilo se neco?

            Console.WriteLine();
            Console.ReadKey();
        }

        /// <summary>
        /// Ukol: vypsat retezce z teto kolekce, ktere splnuji vlastnost palindromu
        /// </summary>
        private static void TestPalindrome()
        {
            Console.WriteLine(nameof(TestPalindrome));
            var words = new[] { "civic", "disco", "level", "numb", "racecar" };

            // TODO:
            // words.PrintPalindromes( ...zde prijde lambda vyraz... );

            Console.WriteLine(Environment.NewLine);
            Console.ReadKey();
        }
    }
}