﻿namespace LocalFunctions
{
    class Program
    {
        /// <summary>
        /// Zadani:
        /// 
        /// Implementujte metodu, ktera na vstupu bere libovolny pocet cisel, 
        /// a na vystupu vrati soucet faktorialu techto cisel. 
        /// Pri implementaci vhodne pouzijte lokalni funkci.
        /// </summary>
        static void Main(string[] args)
        {
            AnonymousTypesDemo();

            LocalFunctionsDemo();
            
            // TODO...

        }

        private static void AnonymousTypesDemo()
        {
            // Priklad anonymniho typu
            var url = "https://example.com";
            var anonymousType1 = new { Site = "Example", Url = url };
            // jmeno lze implicitne odvodit
            var anonymousType2 = new { Site = "Example", url };

            // Anonymni typy json immutable
            //anonymousType1.Site = "Another example";

            // Pozor na porovnavani
            var anonymousType3 = new { Site = "Example", Url = url };
            Console.WriteLine(anonymousType1 == anonymousType3); // => False
            Console.WriteLine(anonymousType1.Equals(anonymousType3)); // => True
        }

        private static void LocalFunctionsDemo()
        {
            // Priklad deklarace trivialni lokalni funkce
            int Sum(int x, int y) => x + y;
            // a jejiho volani
            Console.WriteLine(Sum(1, 2));

            // Pro srovnani zapis stejne funkce pomoci lambda vyrazu:
            Func<int, int, int> sum = (x, y) => x + y;
            Console.WriteLine(sum(1, 2));
            // Rozdily mezi lambda vyrazy a lokalnimi funkcemi jsou shrnuty nize
        }
    }
}
